   program dielectric
   use read_parms
   implicit none
   
   integer model,ensteps,i,mu,nval,k,n1,n2,nk,norb,ncond,ndim,ik,b,n,c
   real(8) q(3),emin,emax,broad,estep,w,m_pi,vol,factor
   integer a1,a2,checkgrad
   integer first,last,d,j,l,ll
   
   real(8), allocatable :: kpt(:,:),egv(:,:),os(:,:),iwk(:)
   complex(8), allocatable :: vtmp(:)
   complex(8) sk

   real(8) kr,efield(3),x,y,z,ost,er,totw,Frule,dx,dy,dz,kvec(3),t1,t2
   
   complex(8), allocatable :: zvect(:,:,:)
   real(8), allocatable :: eps1(:),eps2(:)
   real(8), allocatable :: e2(:),deltae(:,:,:),sptot(:,:,:)
   complex(8), allocatable :: A(:,:,:,:),H(:,:),derH(:,:)
   real(8), allocatable :: F(:,:,:,:)
   complex(8) temp 
   
   parameter(m_pi=3.14159265358979323846)
   
   real(8), parameter :: ual=0.5291772083
   real(8), parameter :: E_B=13.6058 
   real(8), parameter :: uae=27.2113834d0
   real(8), parameter :: eps=0.01d0

   open(unit=10,file='eigenvalues.dat',form='formatted',status='old') 
   open(unit=11,file='eigenvectors.dat',form='unformatted',status='old')
   open(unit=12,file='dielectric.input',form='formatted',status='old')

   read (10,'(/35x,i6)') nk
   read (10,'(35x,i6)') nval
   read (10,'(35x,i6)') ncond

   write(*,*) "***** Calculation of the dielectric constant ******" 
   write(*,*) "*****      epsilon(w,0) for bulk silicon     ******" 

   write(*,*) ' Number of k points = ',nk
   write(*,*) ' Number of valence  = ',nval
   write(*,*) ' Number of conductions = ',ncond
   
   ndim=nval+ncond
   norb=4
   
   write(*,*) ' Check Gradient H (1/0)'
   read(5,*) checkgrad
   if(checkgrad.eq.1)  nk=1 
   
   ALLOCATE(kpt(3,nk),zvect(ndim,ndim,nk),egv(ndim,nk),A(8,8,3,nk),iwk(nk), &
   &F(4,4,3,nk),vtmp(8),deltae(4,4,nk),H(8,8),derH(8,8),sptot(nk,4,4))
  
   d=1 
   if(checkgrad.eq.1) then
   kpt(1,1)=0.1d0
   kpt(2,1)=0.2d0
   kpt(3,1)=0.3d0
   call gradoffdiagonal(nk,kpt,A)
   kvec(:)=kpt(:,1)
   kvec(d)=kpt(d,1)+eps
   H=(0.d0,0.d0)
   call fill_offdiagonal(kvec,H)
   derH=H
   kvec(:)=kpt(:,1)
   kvec(d)=kpt(d,1)-eps
   H=(0.d0,0.d0)
   call fill_offdiagonal(kvec,H)
   derH=(derH-H)/(2.d0*eps)

   do i=1,8
    do j=1,8
    write(*,'(2i,4f9.4)') i,j,derH(i,j),A(i,j,d,1)/16.d0
    enddo
    enddo
   stop
   endif

   
   totw=0.d0
   do ik=1,nk
    read(10,*) (kpt(i,ik),i=1,3),iwk(ik),(egv(i,ik),i=1,ndim)
    read(11) ((zvect(c,b,ik),c=1,ndim),b=1,ndim)
    totw=iwk(ik)+totw
   enddo
   iwk=iwk/totw
   
   write(*,*) ' Q vector : '
   read(12,*)
   read(12,*)   emin,emax   
   write(*,*)  'Energy range: ',emin,emax
   read(12,*)
   read(12,*)   broad   
   write(*,*)  'Broadening: ',broad
   read(12,*)
   read(12,*)   ensteps  
   write(*,*)  'Energy steps: ',ensteps 
   read(12,*)
   read(12,*)   first
   if(first.eq.0) first=1
   write(*,*)  'First Band: ',first 
   read(12,*)
   read(12,*)   last
   if(last.eq.0) last=nval+ncond
   write(*,*)  'Last Conduction Band: ',last
   read(12,*)
   read(12,*)   (efield(i),i=1,3)  
   
   if(first.gt.nval.or.last.gt.nval+ncond) then
           stop ' ERROR first or last band wrong! '
   endif
   
   allocate(eps1(ensteps),eps2(ensteps))

   open(unit=13,file='e0w.rpa',form='formatted',status='unknown')

   estep=(emax-emin)/dble(ensteps)
  
   nval=4
   
   kpt=2.d0*M_PI*kpt
   
   call gradoffdiagonal(nk,kpt,A)

    A=A/4.d0  

!   A=A/16.d0
!   A=A*acell/ual
!   A=A/uae
   
     do k=1,nk 
      do n1=1,4
       do n2=5,8
        deltae(n1,n2-4,k)=egv(n2,k)-egv(n1,k)
        do l=1,3
        vtmp=dcmplx(0.d0,0.d0)
        vtmp=matmul(A(:,:,l,k),zvect(:,n1,k))
!        sk=dot_product(dconjg(zvect(:,n2,k)),vtmp)
        sk=dot_product(zvect(:,n2,k),vtmp)
        F(n1,n2-4,l,k)=cdabs(sk)**2
       enddo
       enddo
      enddo
     enddo


     do k=1,nk 
      do n1=1,4
       do n2=1,4
       sptot(k,n1,n2)=sum(F(n1,n2,:,k))
       enddo
      enddo
     enddo
        
!   F=2.d0*F*uae
!     
!   vol=1.d0/4.d0*(acell/ual)**3
!   factor=4.d0*m_pi/vol
   
  
   Frule=0.d0
   
   do n=1,ensteps
   w=emin+(n-1)*estep
   eps1(n)=0.d0
   eps2(n)=0.d0
  
     do k=1,nk 
      do n1=1,4
       do n2=1,4
        eps2(n)=eps2(n)+sptot(k,n1,n2)*iwk(k)*broad &
        &/((deltae(n1,n2,k)-w)**2+broad**2)/deltae(n1,n2,k)**2
        
         eps2(n)=eps2(n)-sptot(k,n1,n2)*iwk(k)*broad &
        &/((deltae(n1,n2,k)+w)**2+broad**2)/deltae(n1,n2,k)**2
        
        eps1(n)=eps1(n)+sptot(k,n1,n2)*iwk(k)*(deltae(n1,n2,k)-w) &
        &/((w-deltae(n1,n2,k))**2+broad**2)/deltae(n1,n2,k)**2
   
        eps1(n)=eps1(n)+sptot(k,n1,n2)*iwk(k)*(deltae(n1,n2,k)+w) &
       &/((w+deltae(n1,n2,k))**2+broad**2)/deltae(n1,n2,k)**2
         enddo
        enddo
      enddo

    eps1(n)=eps1(n)*4.d0*M_PI*e_b*ual/acell/3.d0
    eps2(n)=eps2(n)*4.d0*M_PI*e_b*ual/acell/3.d0
   
    eps1(n)=eps1(n)+1.d0
    
    Frule=eps2(n)*(emin+(i-1)*estep)*estep+Frule
    
    write(*,'(3f9.4)') w,eps1(n),eps2(n)
     enddo

!   write(*,*) ' Frule = ',Frule*acell**3/4.d0/ual**3*(2.d0*8.d0*m_pi**2)/uae
     
    
   do i=1,ensteps
    w=emin+(i-1)*estep
    write(13,'(4e)') w,eps1(i),eps2(i)
   enddo
   
   close(13)
   close(12)
   close(10)
   close(11)
   end program dielectric


 
