program DOS
  
  implicit none
  integer ndiv,nbands,nkpt,nband,i,k,q,h
  real(8) emin,emax,delta,de,inc,kvec(3),iwk,totw
  real(8), allocatable  :: histo(:)
  real(8), allocatable :: dhisto(:),values(:)
  real(8) ,parameter :: M_PI=3.14159265358979323846
  character(20) filename

   write(*,*) ' Density of states for Silicon Tight-Binding '
!  write(*,*) ' File :'
!  read(5,*) filename
   filename='eigenvalues.dat'
!  write(*,*) ' Number of bands :'
!  read(5,*) nband
   nband=8
  open(unit=11,file = trim(filename), form = 'formatted', status = 'old')
   read(11,*)
   read(11,*)
   read(11,*)
   read(11,*)
  do i=1,100000
   read(11,*,end=100) kvec(1),kvec(2),kvec(3)
   write(*,*) ' kvec ',kvec(1),kvec(2),kvec(3)
  enddo

100 nkpt=i-1
  write(*,*) ' Number of k-point :',nkpt
  write(*,*) ' Delta :'
  read(5,*) delta
  allocate(values(nband))
  
  emin=100d10
  emax=-100d10
  rewind(11)
   read(11,*)
   read(11,*)
   read(11,*)
   read(11,*)
 totw=0.d0
 do k=1,nkpt
   read(11,*) kvec(1),kvec(2),kvec(3),iwk,(values(i),i=1,nband)
   totw=iwk+totw
   do i=1,nband
      if(values(i)<emin) emin=values(i)
      if(values(i)>emax) emax=values(i)
  enddo
 enddo
        
 write(*,*) ' Data Range ',emin,emax
 write(*,*) ' Emin :'
 read(*,*) emin
 write(*,*) ' Emax :'
 read(*,*) emax
 write(*,*) ' Ndiv :'
 read(5,*) ndiv
 
 allocate(histo(ndiv),dhisto(ndiv))

 dhisto=0.d0
 histo=0.d0
 de=(emax-emin)/dble(ndiv)
 
 rewind(11)
   read(11,*)
   read(11,*)
   read(11,*)
   read(11,*)
 
 do q=1,nkpt 
  read(11,*) kvec(1),kvec(2),kvec(3),iwk,(values(i),i=1,nband)
   do i=1,nband
    do h=1,ndiv
     inc=1.d0/delta/dsqrt(2.d0*M_PI)*dexp(-(values(i)-emin-(h-0.5)*de)**2/delta**2/2.d0)*iwk
     if(values(i)-emin.ge.de*(h-1).and.values(i)-emin.lt.de*h) histo(h)=histo(h)+iwk
!    write(*,*) ' diff ',inc,dhisto(h)
     dhisto(h)=dhisto(h)+inc
   enddo
  enddo
 enddo


 histo=histo/totw
 dhisto=dhisto/totw
 
 close(11)
 open(10,file = 'dos.dat', form = 'formatted', status = 'unknown')
 do i=1,ndiv
  write(10,*) emin+(i-0.5)*de,histo(i),dhisto(i)
 enddo
 close(10)
end program DOS
