  program main
  implicit none
  
! Base vectors
  integer base1(3),base2(3)

! Lattice vectors
  integer l(3,3)

! Number of atoms to be allocated at once.

!****** Max range (in lattice vectors) spanned to create the nanowire
  integer , parameter :: maxL = 10

  integer atom1(3),atom2(3),d1,d2,i,k,j,d
  integer fnn(3,4),snn(3,12),tnn(3,12),ifn,isn,itn
  
  integer, parameter :: d1NN = 48
  integer, parameter :: d2NN = 128
  integer, parameter :: d3NN = 176
! base vectors in units of a/16
  base1=0

  base2(1)=4
  base2(2)=4
  base2(3)=4
  
! lattice vectors in units a/16

  l(1,1)=0
  l(2,1)=8
  l(3,1)=8
  
  l(1,2)=8
  l(2,2)=0
  l(3,2)=8
  
  l(1,3)=8
  l(2,3)=8
  l(3,3)=0
     
  ifn=1
  isn=1
  itn=1
  
  do i=-maxL,maxL
   do j=-maxL,maxL
    do k=-maxL,maxL
     do d=1,3
     atom1(d)=base1(d)+l(d,1)*i+l(d,2)*j+l(d,3)*k
     atom2(d)=base2(d)+l(d,1)*i+l(d,2)*j+l(d,3)*k
    enddo 

     d1=atom1(1)**2+atom1(2)**2+atom1(3)**2
     d2=atom2(1)**2+atom2(2)**2+atom2(3)**2
    
     if(d2==d1NN) then 
             write(*,*) 'First Nearest Neighbor ',ifn
        do d=1,3
         fnn(d,ifn)=atom2(d)
        enddo
        ifn=ifn+1                    
     endif
    
     if(d1==d2NN) then 
       write(*,*) 'Second Nearest Neighbor ',isn
      do d=1,3
        snn(d,ifn)=atom1(d)
      enddo
       isn=isn+1                    
     endif

      if(d2==d3NN) then 
       write(*,*) 'Third Nearest Neighbor ',itn
      do d=1,3
        tnn(d,ifn)=atom2(d)
      enddo
       itn=itn+1                    
     endif
     
    enddo 
   enddo
  enddo
  end program main
