
      module read_parms
      implicit none
      real(8) ESS(2),EPP(2),EDD(2),ETT(2),ESSS(2,2),ETTS(2,2), &   
     &  ESTS(2,2),ESPS(2,2),ETPS(2,2),ESDS(2,2),ETDS(2,2),EPPS(2,2), &  
     &  EPPP(2,2),EPDS(2,2),EPDP(2,2),EDDS(2,2),EDDP(2,2),EDDD(2,2)   
      real(8) EH,USSS,USPS,USDS,UTDS                         
      CHARACTER(14) CH(42)
      public :: read_file
      
      contains
     
      subroutine read_file
      implicit none
      integer untfree

      untfree=10

50    FORMAT (A14,F9.5,A14,F9.5)
      
      open(unit=untfree,file='sp3d5t.SiSi',form='formatted',status='old')
      READ (untfree,*) ESS(1)
      READ (untfree,*) ESS(2)
      READ (untfree,*) EPP(1)
      READ (untfree,*) EPP(2)
      READ (untfree,*) EDD(1)
      READ (untfree,*) EDD(2)
      READ (untfree,*) ETT(1) 
      READ (untfree,*) ETT(2) 
      READ (untfree,*) ESSS(1,2)                                
      READ (untfree,50)CH(10),ETTS(1,2)                                
      ETTS(2,1) = ETTS(1,2)                                 
      READ (untfree,50)CH(11),ESTS(1,2),CH(12),ESTS(2,1)          
      READ (untfree,50)CH(13),ESPS(1,2),CH(14),ESPS(2,1)          
      READ (untfree,50)CH(15),ETPS(1,2),CH(16),ETPS(2,1)          
      READ (untfree,50)CH(17),ESDS(1,2),CH(18),ESDS(2,1)          
      READ (untfree,50)CH(19),ETDS(1,2),CH(20),ETDS(2,1)          
      READ (untfree,50)CH(21),EPPS(1,2)                           
      EPPS (2,1) = EPPS(1,2)                                
      READ (untfree,50)CH(22),EPPP(1,2)                           
      EPPP(2,1) = EPPP(1,2)                                 
      READ (untfree,50)CH(23),EPDS(1,2),CH(24),EPDS(2,1)          
      READ (untfree,50)CH(25),EPDP(1,2),CH(26),EPDP(2,1)          
      READ (untfree,50)CH(27),EDDS(1,2)                           
      EDDS(2,1) = EDDS(1,2)                                 
      READ (untfree,50)CH(28),EDDP(1,2)                           
      EDDP(2,1) = EDDP(untfree,2)                                 
      READ (untfree,50)CH(29),EDDD(1,2)                           
      EDDD(2,1) = EDDD(1,2)   
       
      close(untfree)
      end subroutine read_file
      
      end module read_parms

      program main
      use read_parms
      implicit none
      integer lwork
      integer n,i,info,l,ndim,counter,ix,iy,iz
      integer j,k,a,b,ncell,d
      complex(8) , ALLOCATABLE :: work(:),H(:,:)
      real(8) , ALLOCATABLE :: rwork(:),eigv(:)
      
      real(8) step,kvec(3),M_PI,x,s2,s3,s6,xn,xl

      real(8) a_fcc(3,3),b_fcc(3,3),acell
      real(8), parameter :: ual = 0.5291772083d0 
      parameter(M_PI=3.14159265358979323846)
     

       a_fcc(1,1)=0.d0
       a_fcc(2,1)=0.5d0
       a_fcc(3,1)=0.5d0
       
       a_fcc(1,2)=0.5d0
       a_fcc(2,2)=0.d0
       a_fcc(3,2)=0.5d0
       
       a_fcc(1,3)=0.5d0
       a_fcc(2,3)=0.5d0
       a_fcc(3,3)=0.d0
       
       b_fcc(1,1)=1.d0
       b_fcc(2,1)=1.d0
       b_fcc(3,1)=-1.d0
       
       b_fcc(1,2)=1.d0
       b_fcc(2,2)=-1.d0
       b_fcc(3,2)=1.d0
       
       b_fcc(1,3)=-1.d0
       b_fcc(2,3)=1.d0
       b_fcc(3,3)=1.d0
       
      ndim=20
      lwork=ndim*100
      
      allocate(work(lwork),rwork(lwork),H(ndim,ndim),eigv(ndim))
      
      call read_file
      write(*,*) ' Number of points for Band Structure'
      read(5,*) n
      step = 2.d0*M_PI/dble(n)
!* Longueur du trace Gamma-X-W-L-Gamma-K-X                               

      XN = FLOAT(N)                                                     
      S2=DSQRT(2.D+00)
      S3=DSQRT(3.D+00)               
      S6=DSQRT(6.D+00)               
      XL = XN*(0.5*S3+1.d0+0.5+0.25*S2+0.25*S6+0.5*S2+0.5+S2) 
      
      open(unit=10,file='bandstructure.dat',form='formatted'&
     &,status='unknown')

      
! L point (1/2,1/2,1/2)
      kvec(1)=0.5d0
      kvec(2)=0.5d0
      kvec(3)=0.5d0
  
      X = -S3/XL 
      
      WRITE (6,*)'L-Gamma'
      WRITE (10,*)'# L'   
      do i=n/2,0,-1
      iy=i
      ix=i
      iz=i
      x=x+S3/xl
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)


      write(*,*) (H(1,d),d=1,ndim)
      stop
      
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 

      WRITE (6,*)'Axe Gamma-X'
      WRITE (10,*)'# G'   
      do i=1,N,1
      iy=0
      iz=0
      ix=i
      x=x+1.d0/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 
     
      WRITE (6,*)' Axe X-W'
      WRITE (10,*)'# X'   
      do i=1,N/2
      iy=i
      iz=0
      ix=N
      x=x+1.d0/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 

       WRITE (6,*)' Axe W-K'
       WRITE (10,*)'# W'   
      do i=1,N/4
      ix=N
      iy=N/2-i
      iz=i
      x=x+S2/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 


      WRITE (6,*)' Axe K-L'
      WRITE (10,*)'# K'   
      do i=1,N/4
      ix=N-2*i
      iy=N/4+i
      iz=iy
      x=x+S6/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 
      
      WRITE (6,*)' Axe L-W'
      WRITE (10,*)'# L'   
      do i=1,N/2
      ix=N/2+i
      iy=N/2
      iz=N/2-i
      x=x+S2/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 

      WRITE (6,*)' Axe W-X'
      WRITE (10,*)'# W'   
      do i=1,N/2
      ix=N
      iy=N/2+i
      iz=0
      x=x+1.d0/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 

      WRITE (6,*)' Axe X-K-Gamma'
      WRITE (10,*)'# X'   
      do i=1,N
      ix=N-i
      iy=ix
      iz=0
      x=x+S2/XL
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') x,(eigv(l),l=1,ndim)
      enddo 

      close(10)
      
      open(unit=10,file='eigenvalues.dat',form='formatted' &
     &,status='unknown')
      open(unit=11,file='eigenvectors.dat',form='unformatted' &
     &,status='unknown')
      open(unit=12,file='structure.wire',form='formatted' &
     &,status='unknown')
      write(*,*) ' Number of k-points for BSE '
      read(5,*) n
      write(*,*) ' Total number of k-points= ',n**3
      write(*,*) ' Number of cells for resum the potential '
      read(5,*) ncell
      write(*,*) ' Total number cells = ',ncell**3

      step=2.d0*M_PI/dble(n)
    
       write(10,'("# Bands ", &
&                  /"# Number of kpoints             = ",i6,  &
&                  /"# Nval                          = ",i6,  &
&                  /"# Ncond                         = ",i6)')&
&  ,n**3,4,ndim-4
        write(10,*) "# Bands "
        write(10,'("# nkpt  ",i4)'),n**3
        write(10,'("# nval  ",i4)'),4
        write(10,'("# ncond ",i4)'),ndim-4

      acell=5.431/ual
      
      do i=1,n
       do j=1,n      
        do k=1,n
        kvec(1)=step*(i*b_fcc(1,1)+j*b_fcc(1,2)+k*b_fcc(1,3))
        kvec(2)=step*(i*b_fcc(2,1)+j*b_fcc(2,2)+k*b_fcc(2,3))
        kvec(3)=step*(i*b_fcc(3,1)+j*b_fcc(3,2)+k*b_fcc(3,3))
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('V','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') (kvec(l)/acell,l=1,3),(eigv(l),l=1,ndim)
      write(11) ((H(a,b),a=1,ndim),b=1,ndim)
        enddo
       enddo 
      enddo
      close(10)
      close(11)
      
        write(12,'("Nanowire ID : ",a,".", &
&                  /"Number of semiconductor atoms = ",i6,   &
&                  /"Number of Hydrogen      atoms = ",i6,   &
&                  /"Number of supercell     atoms = ",i6,   &
                   /"Number of cells               = ",i6,   &
                   /"Number of orbitals for Si     = ",i6') &
&  "SolidSilicon", 2, 0, 2, ncell**3,10
       write(12,'("Uwire: ",3e,/"Lwire: ",f10.5)') &
     &, 0.d0,0.d0,0.d0,0.d0
       write(12,'("Radius: ",f10.5)') 0.d0
       write(12,'("Acell : ",f10.5)') acell*ual
       write(12,'(3e,i4)') 0.d0,0.d0,0.d0,1
       write(12,'(3e,i4)') 0.25d0*acell,0.25d0*acell,0.25d0*acell,2
       write(12,*) 'Position of atomic orbitals'
       do i=1,10
         write(12,*) 1
       enddo
       do i=1,10
         write(12,*) 2
       enddo
       write(12,*) 'Lattice Vectores'
      do i=-(ncell-1)/2,(ncell-1)/2
       do j=-(ncell-1)/2,(ncell-1)/2
         do k=-(ncell-1)/2,(ncell-1)/2
        write(12,*) acell*(a_fcc(1,1)*i+a_fcc(1,2)*j+a_fcc(1,3)*k),  &
     &              acell*(a_fcc(2,1)*i+a_fcc(2,2)*j+a_fcc(2,3)*k),  &
     &              acell*(a_fcc(3,1)*i+a_fcc(3,2)*j+a_fcc(3,3)*k) 
        enddo
       enddo 
      enddo
      close(12)
      end program main

      subroutine fill_diagonal(H)  
      use read_parms
      implicit none
      complex(8) H(20,20)
      integer IL,I,J
      IL = 0                                                          
      DO  I=1,2                                          
        IL = IL+1                                          
        H(IL,IL) = DCMPLX(ESS(I),0.d0)
        DO  J=1,3                                         
          IL = IL+1                                         
          H(IL,IL) = DCMPLX(EPP(I),0.d0)
        enddo
        DO  J=1,5                                         
          IL = IL+1                                         
          H(IL,IL) = DCMPLX(EDD(I),0.d0)                                
        enddo
        IL = IL+1                                           
        H(IL,IL) = DCMPLX(ETT(I),0.d0) 
      enddo
      end subroutine fill_diagonal

      subroutine fill_offdiagonal(kvec,H)  
      use read_parms
      implicit none
      complex(8) H(20,20)
      real(8) kvec(3),V(3,4),HV(10,10),X,Y,Z,XN,L,M,P,PHI
      integer IL,I,J,IV,II,JJ,norb

      norb=10

      V(1,1)=1.d0
      V(2,1)=1.d0
      V(3,1)=1.d0
      
      V(1,2)=-1.d0
      V(2,2)=-1.d0
      V(3,2)=1.d0
      
      V(1,3)=-1.d0
      V(2,3)=1.d0
      V(3,3)=-1.d0
      
      V(1,4)=1.d0
      V(2,4)=-1.d0
      V(3,4)=-1.d0
      
       DO IV=1,4                                           
! Neighboards in A units                                                
        X = V(1,IV)/4.D+00                                             
        Y = V(2,IV)/4.D+00                                            
        Z = V(3,IV)/4.D+00                                             
        XN = DSQRT( X**2+Y**2+Z**2)                                     
        L = X/XN                                                       
        M = Y/XN                                                       
        P = Z/XN                                                       

        PHI = kvec(1)*X+kvec(2)*Y+kvec(3)*Z                        
        
       CALL INIH1(HV,L,M,P,10)                                       
!************************************************************************
        DO  II=1,norb                                                
          DO  JJ=1,norb                                              
   H(II,norb+JJ) = H(II,norb+JJ)+HV(II,JJ)*DCMPLX(dcos(phi),dsin(phi))
          enddo
         enddo
!************************************************************************
        enddo                                                          
      end subroutine fill_offdiagonal
              
      SUBROUTINE INIH1(H,L,M,P,NF_AT)                                   
      use read_parms
      IMPLICIT none                                                  
      integer NF_AT
      real(8) H(NF_AT,NF_AT)                                        
      REAL*8 L,M,P,s3
      S3 = DSQRT(3.D+00)                                              
!* <s|s>                                                                 
      H(1,1) = +ESSS(1,2)                                             
      H(1,2) = +L*ESPS(1,2)                                           
      H(1,3) = +M*ESPS(1,2)                                           
      H(1,4) = +P*ESPS(1,2)                                           
!* <s|xy>                                                                
      H(1,5) = +S3*L*M*ESDS(1,2 )                                     
      H(1,6) = +S3*M*P*ESDS(1,2 )                                     
      H(1,7) = +S3*P*L*ESDS(1,2 )                                     
!* <s|x**2-y**2>                                                         
      H(1,8) = +0.5D+00*S3*(L*L-M*M)*ESDS(1,2)                       
      H(1,9) = +(P*P-0.5D+00*(L*L+M*M))*ESDS(1,2)                    
!* <s|t>                                                                 
      H(1,10) = +ESTS(1,2)                                            
!************************************************************************
!* <x|s>                                                                 
      H(2,1) = -L*ESPS(2,1)                                           
!* <x|x>                                                                 
      H(2,2) = +EPPP(1,2) +(L**2)*(EPPS(1,2)-EPPP(1,2))               
      H(2,3) = +L*M*(EPPS(1,2) -EPPP(1,2))                            
      H(2,4) = +L*P*(EPPS(1,2) -EPPP(1,2))                            
!* <x|xy>                                                                
      H(2,5) = +S3*L*L*M*EPDS(1,2)+M*(1.D+00-2.D+00*L*L)*EPDP(1,2)  
      H(2,6) = +S3*L*M*P*EPDS(1,2)-2.D+00*L*M*P*EPDP(1,2)           
      H(2,7) = +S3*L*L*P*EPDS(1,2)+P*(1.D+00-2.D+00*L*L)*EPDP(1,2)   
!* <x|x**2-y**2>                                                         
      H(2,8) = +0.5D+00*S3*L*(L*L-M*M)*EPDS(1,2)+L*(1.D+00-L*L+M*M)*EPDP(1,2)
      H(2,9) = +L*(P*P-0.5D+00*(L*L+M*M))*EPDS(1,2)-S3*L*P*P*EPDP(1,2)
!* <x|t>                                                                 
      H(2,10) = -L*ETPS(2,1)                                          
!************************************************************************
!* <y|s>                                                                 
      H(3,1) = -M*ESPS(2,1)                                           
!* <y|x>                                                                 
      H(3,2) = +M*L*(EPPS(1,2)-EPPP(1,2))                            
      H(3,3) = +EPPP(1,2)+ (M**2)*(EPPS(1,2)-EPPP(1,2))               
      H(3,4) = +M*P*(EPPS(1,2)-EPPP(1,2))                            
!* <y|xy>                                                                
      H(3,5) = +S3*M*M*L*EPDS(1,2)+L*(1.D+00-2.D+00*M*M)*EPDP(1,2)   
      H(3,6) = +S3*M*M*P*EPDS(1,2)+P*(1.D+00-2.D+00*M*M)*EPDP(1,2)   
      H(3,7) = +S3*L*M*P*EPDS(1,2)-2.D+00*L*M*P*EPDP(1,2)            
!* <y|x**2-y**2>                                                         
      H(3,8) = +0.5D+00*S3*M*(L*L-M*M)*EPDS(1,2)-M*(1.D+00+L*L-M*M)*EPDP(1,2)
      H(3,9) = +M*(P*P-0.5D+00*(L*L+M*M))*EPDS(1,2)-S3*M*P*P*EPDP(1,2)
!* <y|t>                                                                 
      H(3,10) = -M*ETPS(2,1)                                          
!************************************************************************
!* <z|s>                                                                 
      H(4,1) = -P*ESPS(2,1)                                           
!* <z|x>                                                                 
      H(4,2) = +P*L*(EPPS(1,2)-EPPP(1,2))                            
      H(4,3) = +P*M*(EPPS(1,2)-EPPP(1,2))                            
      H(4,4) = +EPPP(1,2) +(P**2)*(EPPS(1,2)-EPPP(1,2))               
!* <z|xy>                                                                
      H(4,5) = +S3*L*M*P*EPDS(1,2)-2.D+00*L*M*P*EPDP(1,2)            
      H(4,6) = +S3*P*P*M*EPDS(1,2)+M*(1.D+00-2.D+00*P*P)*EPDP(1,2)   
      H(4,7) = +S3*P*P*L*EPDS(1,2)+L*(1.D+00-2.D+00*P*P)*EPDP(1,2)   
!* <z|x**2-y**2>                                                         
      H(4,8) = +0.5D+00*S3*P*(L*L-M*M)*EPDS(1,2)-P*(L*L-M*M)*EPDP(1,2)
      H(4,9) = +P*(P*P-0.5D+00*(L*L+M*M))*EPDS(1,2)+S3*P*(L*L+M*M)*EPDP(1,2)
!* <z|t>                                                                 
      H(4,10) = -P*ETPS(2,1)                                          
!************************************************************************
!* <xy|s>                                                                
      H(5,1) = +S3*L*M*ESDS(2,1)                                     
!* <xy|x>                                                                
      H(5,2) = -S3*L*L*M*EPDS(2,1)-M*(1.D+00-2.D+00*L*L)*EPDP(2,1)   
      H(5,3) = -S3*M*M*L*EPDS(2,1)-L*(1.D+00-2.D+00*M*M)*EPDP(2,1)   
      H(5,4) = -S3*L*M*P*EPDS(2,1)+2.D+00*L*M*P*EPDP(2,1)            
!* <xy|xy>                                                               
      H(5,5) = +3.D+00*L*L*M*M*EDDS(1,2)+(L*L+M*M-4.D+00*L*L*M*M)*EDDP(1,2) &
     &+(P*P+L*L*M*M)*EDDD(1,2)
      H(5,6) = +3.D+00*L*M*M*P*EDDS(1,2)+L*P*(1.D+00-4.D+00*M*M)*EDDP(1,2 ) &
     &+L*P*(M*M-1.D+00)*EDDD(1,2)                       
      H(5,7) = +3.D+00*L*L*M*P*EDDS(1,2)+M*P*(1.D+00-4.D+00*L*L)*EDDP(1,2 ) &
     &+M*P*(L*L-1.D+00)*EDDD(1,2)                       
!* <xy|x**2-y**2>                                                        
      H(5,8) =+1.5D+00*L*M*(L*L-M*M)*EDDS(1,2)+2.D+00*L*M*(M*M-L*L)*EDDP(1,2) &
     &+0.5D+00*L*M*(L*L-M*M)*EDDD(1,2)
      H(5,9) = +S3*L*M*(P*P-0.5D+00*(L*L+M*M))*EDDS(1,2)        &
     &-2.D+00*S3*L*M*P*P*EDDP(1,2)+0.5*S3*L*M*(1.D+00+P*P)*EDDD(1,2)
!* <xy|t>                                                                
      H(5,10) = +S3*L*M*ETDS(2,1)                                    
!************************************************************************
!* <yz|s>                                                                
      H(6,1) = +S3*M*P*ESDS(2,1)                                     
!* <yz|x>                                                                
      H(6,2) = -S3*L*M*P*EPDS(2,1)+2.D+00*L*M*P*EPDP(2,1)            
      H(6,3) = -S3*M*M*P*EPDS(2,1)-P*(1.D+00-2.D+00*M*M)*EPDP(2,1)   
      H(6,4) = -S3*M*P*P*EPDS(2,1)-M*(1.D+00-2.D+00*P*P)*EPDP(2,1)   
!* <yz|xy>                                                               
      H(6,5) = +3.D+00*L*M*M*P*EDDS(1,2)+L*P*(1.D+00-4.D+00*M*M)*EDDP(1,2 ) &
     & +L*P*(M*M-1.D+00)*EDDD(1,2)                       
      H(6,6) = +3.D+00*M*M*P*P*EDDS(1,2)+(M*M+P*P-4.D+00*M*M*P*P)*EDDP(1,2) &
     &+(L*L+M*M*P*P)*EDDD(1,2)
      H(6,7) = +3.D+00*L*M*P*P*EDDS(1,2)+L*M*(1.D+00-4.D+00*P*P)*EDDP(1,2 ) &
     &+L*M*(P*P-1.D+00)*EDDD(1,2)
!* <yz|x**2-y**2)                                                        
      H(6,8) = +1.5D+00*M*P*(L*L-M*M)*EDDS(1,2) &     
     &  -M*P*(1.+2.D+00*(L*L-M*M))*EDDP(1,2)    &                     
     &  +M*P*(1.D+00+0.5D+00*(L*L-M*M))*EDDD(1,2)                    
      H(6,9) = +S3*M*P*(P*P-0.5D+00*(L*L+M*M))*EDDS(1,2)             &
     &  +S3*M*P*(L*L+M*M-P*P)*EDDP(1,2)-0.5D+00*S3*M*P*(L*L+ M*M)    &
     &  *EDDD(1,2)                                                    
!* <yz|s>                                                            
      H(6,10) = +S3*M*P*ETDS(2,1)                                    
!************************************************************************
!* <zx|s>                                                                
      H(7,1) = +S3*P*L*ESDS(2,1)  
!* <zx|x>                                                                
      H(7,2) = -S3*L*L*P*EPDS(2,1)-P*(1.D+00-2.D+00*L*L)*EPDP(2,1)   
      H(7,3) = -S3*L*M*P*EPDS(2,1)+2.D+00*L*M*P*EPDP(2,1)           
      H(7,4) = -S3*L*P*P*EPDS(2,1)-L*(1.D+00-2.D+00*P*P)*EPDP(2,1) 
!* <zx|xy>                                                               
      H(7,5) = +3.D+00*L*L*M*P*EDDS(1,2)+M*P*(1.D+00-4.D+00*L*L) & 
     &  *EDDP(1,2 ) +M*P*(L*L-1.D+00)*EDDD(1,2)                   
      H(7,6) = +3.D+00*L*M*P*P*EDDS(1,2)+L*M*(1.D+00-4.D+00*P*P) &
     &  *EDDP(1,2 ) +L*M*(P*P-1.D+00)*EDDD(1,2)                   
      H(7,7) = +3.D+00*L*L*P*P*EDDS(1,2)+(L*L+P*P-4.D+00*L*L*P*P)&
     &  *EDDP(1,2)+(M*M+L*L*P*P)*EDDD(1,2)                       
!* <zx|x**2-y**2)                                                        
      H(7,8) = +1.5D+00*L*P*(L*L-M*M)*EDDS(1,2)   &             
     &  +L*P*(1.D+00-2.D+00*(L*L-M*M))*EDDP(1,2)  &            
     &  -L*P*(1.-0.5D+00*(L*L-M*M))*EDDD(1,2)                 
      H(7,9) = +S3*L*P*(P*P-0.5D+00*(L*L+M*M))*EDDS(1,2)         &  
     &  +S3*L*P*(L*L+M*M-P*P)*EDDP(1,2)-0.5D+00*S3*L*P*(L*L+M*M) & 
     &  *EDDD(1,2)                                                
!* <zx|s>                                                                
      H(7,10) = +S3*P*L*ETDS(2,1)                                       
!************************************************************************
!* <x**2-y**2|s>                                                         
      H(8,1) = +0.5D+00*S3*(L*L-M*M)*ESDS(2,1)                          
!* <x**2-y**2|x>                                                        
      H(8,2) = -0.5D+00*S3*L*(L*L-M*M)*EPDS(2,1)-L*(1.D+00-L*L+M*M) &   
     &  *EPDP(2,1)                                                      
      H(8,3) = -0.5D+00*S3*M*(L*L-M*M)*EPDS(2,1)+M*(1.D+00+L*L-M*M) &   
     &  *EPDP(2,1)                                                      
      H(8,4) = -0.5D+00*S3*P*(L*L-M*M)*EPDS(2,1)+P*(L*L-M*M)*EPDP(2,1)  
!* <x**2-y**2|xy>                                                        
      H(8,5) = +1.5D+00*L*M*(L*L-M*M)*EDDS(1,2)+2.D+00*L*M*(M*M-L*L) &  
     &  *EDDP(1,2)+0.5D+00*L*M*(L*L-M*M)*EDDD(1,2)                      
      H(8,6) = +1.5D+00*M*P*(L*L-M*M)*EDDS(1,2)                      &  
     &  -M*P*(1.+2.D+00*(L*L-M*M))*EDDP(1,2)                         &  
     &  +M*P*(1.D+00+0.5D+00*(L*L-M*M))*EDDD(1,2)                       
      H(8,7) = +1.5D+00*L*P*(L*L-M*M)*EDDS(1,2)                      &  
     &  +L*P*(1.D+00-2.D+00*(L*L-M*M))*EDDP(1,2)                     &  
     &  -L*P*(1.-0.5D+00*(L*L-M*M))*EDDD(1,2)                           
!* <x**2-y**2|x**2-y**2>                                                 
      H(8,8) = +0.75*(L*L-M*M)**2*EDDS(1,2)+(L*L+M*M-(L*L-M*M)          &
     &  *(L*L-M*M) )*EDDP(1,2)+(P*P+0.25*(L*L-M*M)*(L*L-M*M))*EDDD(1,2) 
      H(8,9) = +0.5D+00*S3*(L*L-M*M)*(P*P-0.5*(L*L+M*M))*EDDS(1,2)      &
     &  +S3*P*P*(M*M-L*L)*EDDP(1,2) +0.25D+00*S3*(1.D+00+P*P)*(L*L-M*M) &
     &  *EDDD(1,2)                                                      
!* <x**2-y**2|t>                                                         
      H(8,10) = +0.5D+00*S3*(L*L-M*M)*ETDS(2,1)                         
!************************************************************************
!* <3*z**2-r**2|s>                                                       
      H(9,1) = +(P*P-0.5D+00 *(L*L+M*M))*ESDS(2,1)                      
!* <3*z**2-r**2|x>                                                       
      H(9,2) = -L*(P*P-0.5D+00*(L*L+M*M))*EPDS(2,1)+S3*L*P*P*EPDP(2,1)  
      H(9,3) = -M*(P*P-0.5D+00*(L*L+M*M))*EPDS(2,1)+S3*M*P*P*EPDP(2,1)  
      H(9,4) = -P*(P*P-0.5D+00*(L*L+M*M))*EPDS(2,1)-S3*P*(L*L+M*M)*EPDP(2,1)
!* <3*z**2-r**2|xy>                                                      
      H(9,5) = +S3*L*M*(P*P-0.5D+00*(L*L+M*M))*EDDS(1,2)               &
     &  -2.D+00*S3*L*M*P*P*EDDP(1,2)+0.5*S3*L*M*(1.D+00+P*P)*EDDD(1,2) 
      H(9,6) = +S3*M*P*(P*P-0.5D+00*(L*L+M*M))*EDDS(1,2)          &    
     &  +S3*M*P*(L*L+M*M-P*P)*EDDP(1,2)-0.5D+00*S3*M*P*(L*L+ M*M) &    
     &  *EDDD(1,2)                                                      
      H(9,7) = +S3*L*P*(P*P-0.5D+00*(L*L+M*M))*EDDS(1,2)           &   
     &  +S3*L*P*(L*L+M*M-P*P)*EDDP(1,2)-0.5D+00*S3*L*P*(L*L+M*M)   &    
     &  *EDDD(1,2)                                                      
!* <3*z**2-r**2|x**2-y**2>                                               
      H(9,8) = +0.5D+00*S3*(L*L-M*M)*(P*P-0.5*(L*L+M*M))*EDDS(1,2)      &
     &  +S3*P*P*(M*M-L*L)*EDDP(1,2) +0.25D+00*S3*(1.D+00+P*P)*(L*L-M*M) &
     &  *EDDD(1,2)                                                      
      H(9,9) = +(P*P-0.5D+00*(L*L+M*M))**2*EDDS(1,2)               &    
     &  +3.D+00*P*P*(L*L+M*M)*EDDP(1,2)+0.75D+00*(L*L+M*M)*(L*L+M*M)  & 
     &  *EDDD(1,2)                                                      
!* <3*z**2-r**2|t>                                                       
      H(9,10) = +(P*P-0.5D+00*(L*L+M*M))*ETDS(2,1)               
!************************************************************************
!* <t|s>                                                                 
      H(10,1) = +ESTS(2,1)                                      
!* <t|x>                                                                 
      H(10,2) = +L*ETPS(1,2)                                   
      H(10,3) = +M*ETPS(1,2)                                  
      H(10,4) = +P*ETPS(1,2)                                 
!* <t|xy>                                                                
      H(10,5) = +S3*L*M*ETDS(1,2)                           
      H(10,6) = +S3*M*P*ETDS(1,2)                          
      H(10,7) = +S3*P*L*ETDS(1,2)                         
!* <t|x**2-y**2>                                                         
      H(10,8) = +0.5D+00*S3*(L*L-M*M)*ETDS(1,2)          
      H(10,9) = +(P*P-0.5D+00*(L*L+M*M))*ETDS(1,2)      
!* <t|t>                                                                 
      H(10,10) = +ETTS(1,2)                          
      RETURN                                          
      END                  
      
