
program main
use read_parms
      implicit none
      integer lwork
      real(8) tempreal,dist
      integer n,i,info,l,ndim,counter,ix,iy,iz
      integer j,k,a,b,ncell,d,sampling
      complex(8) , ALLOCATABLE :: work(:),H(:,:)
      real(8) , ALLOCATABLE :: rwork(:),eigv(:)
      
      real(8) step,kvec(3),M_PI,x,s2,s3,s6,xn,xl

      real(8) a_fcc(3,3),b_fcc(3,3),uacell
      real(8), parameter :: ual = 0.5291772083d0 
      parameter(M_PI=3.14159265358979323846)
      integer, parameter :: nmaxk = 100000
      integer iwk(nmaxk),ikk(nmaxk,3),dwk(nmaxk)
      real(8) kk(nmaxk,3)
      integer nk,ii,jj

      counter=0

       a_fcc(1,1)=0.d0
       a_fcc(2,1)=0.5d0
       a_fcc(3,1)=0.5d0
       
       a_fcc(1,2)=0.5d0
       a_fcc(2,2)=0.d0
       a_fcc(3,2)=0.5d0
       
       a_fcc(1,3)=0.5d0
       a_fcc(2,3)=0.5d0
       a_fcc(3,3)=0.d0
       
       b_fcc(1,1)=1.d0
       b_fcc(2,1)=1.d0
       b_fcc(3,1)=-1.d0
       
       b_fcc(1,2)=1.d0
       b_fcc(2,2)=-1.d0
       b_fcc(3,2)=1.d0
       
       b_fcc(1,3)=-1.d0
       b_fcc(2,3)=1.d0
       b_fcc(3,3)=1.d0
       
      ndim=8
      lwork=ndim*100
      
      allocate(work(lwork),rwork(lwork),H(ndim,ndim),eigv(ndim))
      
      write(*,*) ' ************************************** '
      write(*,*) ' **  Tight-Binding Code for Silicon  ** '
      write(*,*) ' ************************************** '
      write(*,*)
      write(*,*)
      write(*,'(a)',advance='no') ' Number of points for Band Structure: '
      read(5,*) n
      step = 2.d0*M_PI/dble(n) 
!* Longueur du trace Gamma-X-W-L-Gamma-K-X                               

      XN = FLOAT(N)                                                     
      S2=DSQRT(2.D+00)
      S3=DSQRT(3.D+00)               
      S6=DSQRT(6.D+00)               
      XL = XN*(0.5*S3+1.d0+0.5+0.25*S2+0.25*S6+0.5*S2+0.5+S2) 
      
      open(unit=20,file='circuit.dat',form='formatted'&
     &,status='unknown')
      open(unit=10,file='bandstructure.dat',form='formatted'&
     &,status='unknown')


      dist=0.d0
      
      WRITE (6,*)'Axe Gamma-X'
      WRITE (10,*)'# G'   
      do i=1,N,1
      ix=i
      iy=0
      iz=0
      x=ix**2+iy**2+iz**2
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      write(20,*) (kvec(l),l=1,3),1.d0
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') dist+dsqrt(x),(eigv(l),l=1,ndim)
      enddo 
     
      dist=dist+dsqrt(x)
      
      WRITE (6,*)' Axe X-W'
      WRITE (10,*)'# X'   
      do i=1,N/2
      ix=N
      iy=0
      iz=i
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      x=(ix-N)**2+iy**2+iz**2
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
!      do ii=1,4
!       do jj=1,4
!       write(*,*) ' H ',jj,ii,H(jj,ii)
!       enddo
!      enddo 
!      stop
      write(20,*) (kvec(l),l=1,3),1.d0
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') dist+dsqrt(x),(eigv(l),l=1,ndim)
      enddo 

      dist=dist+dsqrt(x)
      
      WRITE (6,*)' Axe W-L'
      WRITE (10,*)'# W'   
      do i=1,N/2
      ix=N-i
      iy=i
      iz=N/2
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      x=(ix-N)**2+iy**2+(iz-N/2)**2
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      write(20,*) (kvec(l),l=1,3),1.d0
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') dist+dsqrt(x),(eigv(l),l=1,ndim)
      enddo 

      dist=dist+dsqrt(x)

      WRITE (6,*)'L-Gamma'
      WRITE (10,*)'# L'   
      do i=n/2,0,-1
      iy=i
      ix=i
      iz=i
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      H=DCMPLX(0.d0,0.d0)
      x=(N/2-ix)**2+(N/2-iy)**2+(N/2-iz)**2
      call fill_diagonal(H)
      write(20,*) (kvec(l),l=1,3),1.d0
      call fill_offdiagonal(kvec,H)
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') dist+dsqrt(x),(eigv(l),l=1,ndim)
      enddo 

      dist=dist+dsqrt(x)

      WRITE (6,*)' Axe Gamma-K'
      WRITE (10,*)'# X'   
      do i=1,3*N/4
      ix=i
      iy=i
      iz=0
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      x=ix**2+iy**2+iz**2
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      write(20,*) (kvec(l),l=1,3),1.d0
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') dist+dsqrt(x),(eigv(l),l=1,ndim)
      enddo 

      dist=dist+dsqrt(x)
      
      WRITE (6,*)' Axe K-X'
      WRITE (10,*)'# K'   
      do i=1,N/4
      ix=3*N/4+i
      iy=3*N/4+i
      iz=0
      kvec(1)=step*ix
      kvec(2)=step*iy
      kvec(3)=step*iz
      x=(ix-3*N/4)**2+(iy-3*N/4)**2+iz**2
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      write(20,*) (kvec(l),l=1,3),1.d0
      call zheev ('N','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') dist+dsqrt(x),(eigv(l),l=1,ndim)
      enddo 
      
       close(10)
       close(20)
      
open(unit=10,file='eigenvalues.dat',form='formatted',status='unknown')
open(unit=11,file='eigenvectors.dat',form='unformatted',status='unknown')
open(unit=12,file='structure.input',form='formatted',status='unknown')

      write(*,'(a)',advance='no') ' Number of k-points for the dielectric constant: '
      read(5,*) n

      write(*,*) ' Sampling type: '
      write(*,*) '0) Stupid sampling '
      write(*,*) '1) Monkhorst Pack  '
      read(*,*)  sampling
   
      if(sampling.eq.1) then
              call  grid(n,nmaxk,ikk,kk,iwk,nk)
              tempreal=0.d0
              do i=1,nk
               tempreal=tempreal+iwk(i)
              enddo
      else
              nk=n**3
      endif
      
       write(10,'("# Bands ", &
&                  /"# Number of kpoints             = ",i6,  &
&                  /"# Nval                          = ",i6,  &
&                  /"# Ncond                         = ",i6)')&
&  ,nk,4,ndim-4

      write(*,*) ' Total number of k-points= ',nk
      write(*,*) ' Number of cells for resum the potential '
      read(5,*) ncell
      write(*,*) ' Total number cells = ',ncell**3
      

      step=1.d0/dble(n)
      
      if(sampling.eq.1) then
        do i=1,nk
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      kvec(1)=2.d0*M_PI*kk(i,1)
      kvec(2)=2.d0*M_PI*kk(i,2)
      kvec(3)=2.d0*M_PI*kk(i,3)
      call fill_offdiagonal(kvec,H)
      call zheev ('V','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') kk(i,:),dble(iwk(i)),eigv(:)
      write(11) ((H(a,b),a=1,ndim),b=1,ndim)
        enddo      
      else
              
      do i=0,n-1
       do j=0,n-1
        do k=0,n-1
        kvec(1)=step*(i*b_fcc(1,1)+j*b_fcc(1,2)+k*b_fcc(1,3))
        kvec(2)=step*(i*b_fcc(2,1)+j*b_fcc(2,2)+k*b_fcc(2,3))
        kvec(3)=step*(i*b_fcc(3,1)+j*b_fcc(3,2)+k*b_fcc(3,3))
        
      H=DCMPLX(0.d0,0.d0)
      call fill_diagonal(H)
      call fill_offdiagonal(kvec,H)
      call zheev ('V','U',ndim,H,ndim,eigv,work,lwork,rwork, info )
      write(10,'(100e15.7)') kvec(:),1.d0,eigv(:)
      write(11) ((H(a,b),a=1,ndim),b=1,ndim)
        enddo
       enddo 
      enddo
      endif
      
      close(10)
      close(11)
end program main


                

