!  13/06/2003
module utilities
use my_types
 contains

   subroutine scambio(ix,iy,iz,l) 
! This subroutine exchanges the coordinates of (Ix,Iy,Iz) vector 
! l decides which ones need to be exchanged. 
      implicit integer(a-z) 
 
       select case(l) 
       case(2) 
        call isost(ix,iy) 
       case(3) 
        call isost(iy,iz) 
       case(4) 
        call isost(ix,iz) 
       case(5) 
        call isost(ix,iy) 
        call isost(iy,iz) 
       case(6) 
        call isost(ix,iy) 
        call isost(ix,iz) 
       end select 
       return 
    end subroutine
 
!  ***********************************************************        
      subroutine invers(ix,iy,iz,l) 
! This subroutine inverts the coordinates of (Ix,Iy,Iz) vector 
! l decides which ones need to be inverted. 
      implicit integer(a-z) 
 
      select case(l) 
      case(2) 
        ix=-ix 
        iy=-iy 
      case(3)
        iy=-iy 
        iz=-iz 
      case(4) 
       ix=-ix 
       iz=-iz   
      end select 
      return 
    end subroutine
!  ***************************************************************** 
 
    subroutine isost(ix,iy) 
      implicit integer(a-z) 
      i=ix 
      ix=iy 
      iy=i 
      return 
    end subroutine
 
!  ***********************************************************        
      subroutine rotatevectint(v,v1,l)
       integer :: v(3),v1(3)

       j=0
       v1=v
       do ls = 1,6
        do li = 1,4
         j=j+1
         if(j == l) then
          call scambio(v1(1),v1(2),v1(3),ls)
          call invers(v1(1),v1(2),v1(3),li)
          return
         endif
         j=j+1
         if(j == l) then
          call scambio(v1(1),v1(2),v1(3),ls)
          call invers(v1(1),v1(2),v1(3),li)
          v1=-v1
          return
         endif
       enddo
      enddo

     return
     end subroutine
!  ***********************************************************  
! 
 
      function indici(id,io) 
      implicit integer(a-z)       
      integer id(3),io(16,2) 
      logical iv(4,4) 
 
      iv=1 
      
      i1=id(1) 
      i2=id(2) 
      i3=id(3) 
 
      if(i3==0) then 
        iv(2,1)=0 
        iv(3,1:2)=0  
        iv(4,1:3)=0 
        if(i2==0) then 
         iv(1:2,3:4)=0 
         iv(3:4,4)=0 
           if(i1==0) then 
           iv(1,2)=0 
           iv(3,3:4)=0 
           endif 
        endif 
      endif 
 
 
      if(i1==i2) then
        iv(1,3)=0 
        iv(3,:)=0 
        iv(4,3)=0 
      endif 
 
      if(i2==i3) then 
        iv(1,4)=0 
        iv(2,4)=0 
        iv(4,:)=0 
      endif 
 
      if(mod(i1+i2+i3,2)==0) then 
        k=2  
      else 
        k=mod(i1+i2+i3,4) 
        iv(2,1)=0 
        iv(3,1:2)=0  
        iv(4,1:3)=0
      endif  
 
      l=0
 
      do i=1,4 
        do j=1,4 
          if(.not.(iv(i,j))) cycle
          l=l+1 
          io(l,1)=i 
          io(l,2)=j 
        enddo
      enddo
  
      if(k==1) io(1:l,1)=io(1:L,1) + 4 
      if(k==3) io(1:l,2)=io(1:L,2) + 4
 
  
      indici=l 
      return
    end function
 
!  ***********************************************************  
 
      subroutine completamat(i1,i2,i3,OUT) 
      real(dp) :: out(4,4)
 
      if(i3==0) then 
        out(2:3,1)=-out(1,2:3) 
        out(4,1)=out(1,4) 
        out(3,2)=out(2,3) 
        out(4,2:3)=-out(2:3,4)
      endif 
 
      if (mod(i1,2)==1) then 
        out(2:4,1)=-out(1,2:4) 
        out(3:4,2)=out(2,3:4) 
        out(4,3)=out(3,4) 
      endif 
 
      
      if(i1==i2) then 
       out(1,3)=out(1,2) 
       out(3,1)=out(2,1) 
       out(3,3)=out(2,2) 
       out(3,4)=out(2,4) 
       out(4,3)=out(4,2) 
       out(3,2)=out(2,3) 
      endif 
 
      if(i2==i3) then 
        out(1,4)=out(1,3) 
        out(4,1)=out(3,1) 
        out(4,4)=out(3,3) 
        out(4,2)=out(3,2) 
        out(2,4)=out(2,3) 
        out(4,3)=out(3,4)
      endif 
 
      if(i1==i3) then 
        out(1,4)=out(1,2) 
        out(4,4)=out(2,2) 
        out(4,3)=out(2,3) 
        out(4,2)=out(2,4) 
        out(4,1)=out(2,1) 
        out(3,4)=out(3,2) 
      endif 
      return  
    end subroutine
 
 
! ************************************************************************ 
      subroutine completamat1(iv,h)
         integer :: iv(3),iv1(3),gv(48)
         real(dp) :: h(4,4),h1(4,4)

         nop = 0
         do l = 1,48
          call rotatevectint(iv,iv1,l)
          if(iv1(1)==iv(1).and.iv1(2)==iv(2).and.iv1(3)==iv(3)) then
             nop = nop + 1 
             gv(nop) = l
          endif
         enddo

         do il = 1,nop
          l = gv(il)
          call rotatemat(h(:,:),h1(:,:),l)
 
          do i = 1,4
           do j = 1,4
             if(h(i,j) == 0.0_dp) h(i,j) = h1(i,j)
           enddo
          enddo
         enddo

       if(mod(iv(1),2)/=0) then
          call scelta(3,h(2:4,1),h(1,2:4),-1)
          call scelta(1,h(3,2),h(2,3),1)
          call scelta(2,h(4,2:3),h(2:3,4),1)
       endif

        return        
        end subroutine

! ************************************************************************ 
  subroutine completadmat(i1,i2,i3,out)
    real(dp) :: out(3,4,4),tmp(4,4),a
    integer :: i1,i2,i3

     if(i1==0 .and. i2==0 .and. i3==0) then
        a = out(1,1,2)
        out(2,1,3)= a
        out(3,1,4)= a
        out(1,2,1) = a
        out(2,3,1) = a
        out(3,4,1) = a
      else
      if(i1==i2 .and. i1==i3) then
       call completamat(3,1,1,out(1,:,:))
       out(1,2:4,1) = out(1,1,2:4)
       out(1,3:4,2) = -out(1,2,3:4)
       out(1,4,3) = -out(1,3,4)
       call rotatemat(out(1,:,:),tmp,9)
       out(2,:,:)=tmp
       call rotatemat(out(1,:,:),tmp,25)
       out(3,:,:)=tmp
       else
       if(i1==i2 .and. i3 ==0) then
        out(1,2:3,1) = out(1,1,2:3)
        out(1,3,2) = -out(1,2,3)
        call rotatemat(out(1,:,:),tmp,9)
        out(2,:,:) = tmp
        out(3,3,4) = out(3,2,4)
        out(3,4,1) = out(3,1,4)
        out(3,4,2) = -out(3,2,4)
        out(3,4,3) = -out(3,3,4)
        else
         if(i2==i3) then
           call completamat(3,1,1,out(1,:,:))
           out(1,2:4,1) = out(1,1,2:4)
           out(1,3:4,2) = -out(1,2,3:4)
           out(1,4,3) = -out(1,3,4)
           call completamat(5,3,1,out(2,:,:))
           out(2,2:4,1) = out(2,1,2:4)
           out(2,3:4,2) = -out(2,2,3:4)
           out(2,4,3) = -out(2,3,4)
           call rotatemat(out(2,:,:),tmp,17)
           out(3,:,:) = tmp
         endif
       endif
      endif
     endif

    return
   end subroutine
! ************************************************************************ 
     subroutine completadmat1(iv,d)
         integer :: iv(3),iv1(3),gv(48)
         real(dp) :: d(3,4,4),dt(3,4,4),d1(3,4,4)

         nop = 0
         do l = 1,48
          call rotatevectint(iv,iv1,l)
          if(iv1(1)==iv(1).and.iv1(2)==iv(2).and.iv1(3)==iv(3)) then
             nop = nop + 1 
             gv(nop) = l
          endif
         enddo

         do il = 1,nop
          l = gv(il)
          do ia = 1,3
           call rotatemat(d(ia,:,:),dt(ia,:,:),l)
          enddo
 
          do i = 1,4
           do j = 1,4
            call rotatevect(dt(:,i,j),d1(:,i,j),l)
            if(mod(l,2)==0) d1 = -d1
            do ia = 1,3
!            if(dabs(p(ia,i,j))>dabs(p1(ia,i,j)).and.p1(ia,i,j)/=0.0_dp.or. &
!            (p(ia,i,j)+p1(ia,i,j))==0.0_dp) p(ia,i,j)=0.0_dp
             if(d(ia,i,j) == 0.0_dp) d(ia,i,j) = d1(ia,i,j)
            enddo
           enddo
          enddo
         enddo

       if(mod(iv(1),2)/=0) then
          do ia = 1,3
           call scelta(3,d(ia,2:4,1),d(ia,1,2:4),1)
           call scelta(1,d(ia,3,2),d(ia,2,3),-1)
           call scelta(2,d(ia,4,2:3),d(ia,2:3,4),-1)
          enddo
       endif

        return        
        end subroutine

! ************************************************************************ 

   subroutine completapmat(i1,i2,i3,out)
    real(dp) :: out(3,4,4),tmp(4,4),a
    integer :: i1,i2,i3
      if(i1==0 .and. i2==0 .and. i3==0) then
        a = out(1,1,2)
        out(2,1,3)= a
        out(3,1,4)= a
        out(1,2,1) = - a
        out(2,3,1) = - a
        out(3,4,1) = - a 
      else
      if(i1==i2 .and. i1==i3) then
       call completamat(3,1,1,out(1,:,:))
       call rotatemat(out(1,:,:),tmp,9)
       out(2,:,:)=tmp
       call rotatemat(out(1,:,:),tmp,25)
       out(3,:,:)=tmp
       else
       if(i1==i2 .and. i3 ==0) then
        call completamat(6,2,0,out(1,:,:))
        call rotatemat(out(1,:,:),tmp,9)
        out(2,:,:) = tmp
        call completamat(3,3,1,out(3,:,:))
        else
         if(i2==i3) then
           call completamat(3,1,1,out(1,:,:))
           call completamat(5,3,1,out(2,:,:))
           call rotatemat(out(2,:,:),tmp,17)
           out(3,:,:) = tmp
         endif
       endif
      endif
     endif

  return
  end subroutine

! ************************************************************************ 
         subroutine completapmat1(iv,p)
         integer :: iv(3),iv1(3),gv(48)
         real(dp) :: p(3,4,4),pt(3,4,4),p1(3,4,4)

         nop = 0
         do l = 1,48
          call rotatevectint(iv,iv1,l)
          if(iv1(1)==iv(1).and.iv1(2)==iv(2).and.iv1(3)==iv(3)) then
             nop = nop + 1 
             gv(nop) = l
          endif
         enddo

         do il = 1,nop
          l = gv(il)
          do ia = 1,3
           call rotatemat(p(ia,:,:),pt(ia,:,:),l)
          enddo
 
          do i = 1,4
           do j = 1,4
            call rotatevect(pt(:,i,j),p1(:,i,j),l)
            do ia = 1,3
!            if(dabs(p(ia,i,j))>dabs(p1(ia,i,j)).and.p1(ia,i,j)/=0.0_dp.or. &
!            (p(ia,i,j)+p1(ia,i,j))==0.0_dp) p(ia,i,j)=0.0_dp
             if(p(ia,i,j) == 0.0_dp) p(ia,i,j) = p1(ia,i,j)
            enddo
           enddo
          enddo
         enddo

       if(mod(iv(1),2)/=0) then
          do ia = 1,3
           call scelta(3,p(ia,2:4,1),p(ia,1,2:4),-1)
           call scelta(1,p(ia,3,2),p(ia,2,3),1)
           call scelta(2,p(ia,4,2:3),p(ia,2:3,4),1)
          enddo
       endif

        return        
        end subroutine


! ************************************************************************ 

        subroutine scelta(n,a,b,is) 
        real(dp) :: a(n),b(n)
        integer :: is
        do i = 1,n
         if(a(i) == 0.0_dp) then
            a(i) = is*b(i)
         else
!        else if(b(i) == 0.0_dp) then
            b(i) = is*a(i)
!        else
!           write(*,*) ' a , b  uguali a 0!!!'
!           stop
         endif
        enddo
        return
        end subroutine

! *************************************************************        
    subroutine ordina(w,w1) 
      integer w(3),w1(3) 
      w1 = iabs(w) 
      if(w1(1) < w1(2)) call isost(w1(1),w1(2)) 
      if(w1(1) < w1(3)) call isost(w1(1),w1(3)) 
      if(w1(2) < w1(3)) call isost(w1(2),w1(3)) 
      
      return
    end subroutine
! ************************************************************************	 
    subroutine trovainv(l,l1)  ! trova l'operazione di simmetria inversa
     integer l,l1,w(3),w1(3),w0(3)  
     w0 = (/1,2,3/)
     call rotatevectint(w0,w,l)  ! w = R_{l}(w0)
      l1 = 0
      do ls=1,6 
        do li=1,4 
          w1=w   ! w1 = w = R_{l}(w0)
          l1 = l1 + 1
          call scambio(w1(1),w1(2),w1(3),ls) 
          call invers(w1(1),w1(2),w1(3),li)  ! w1 -> R_{l1}(w1)
          if( w0(1)==w1(1) .and. w0(2)==w1(2) .and. w0(3)==w1(3) ) return ! w1 == w0 => R_{l1}(w) = w0
          l1 = l1 + 1
          w1=-w1 
          if( w0(1)==w1(1) .and. w0(2)==w1(2) .and. w0(3)==w1(3) ) return 
        enddo
      enddo
    return
    end subroutine trovainv

! ************************************************************************	 

      function rsimm(w)  ! Trova l'operazione di simmetria che trasforma un vettore k irriducibile in w
      implicit integer(a-z) 
      dimension w(3),w0(3),w1(3) 
      call ordina(w,w0) 
      rsimm=0 
      do ls=1,6 
        do li=1,4 
          w1=w0 
          rsimm=rsimm+1 
          call scambio(w1(1),w1(2),w1(3),ls) 
          call invers(w1(1),w1(2),w1(3),li) 
          if( w(1)==w1(1) .and. w(2)==w1(2) .and. w(3)==w1(3) ) return 
          rsimm=rsimm+1 
          w1=-w1 
          if( w(1)==w1(1) .and. w(2)==w1(2) .and. w(3)==w1(3) ) return
        enddo
      enddo
      return
      end function
 
! ************************************************************************	 
      function indice(w) 
      integer :: w(3),w1(3),i1,i2,i3,indice
      call ordina(w,w1)
 
      indice=0 
      do i1=0,3 
        do i2=mod(i1,2),i1,2 
         do i3=mod(i2,2),i2,2 
            if (mod(i1+i2+i3,4) == 2) cycle
            indice = indice + 1 
            if (w1(1)==i1.and.w1(2)==i2.and.w1(3)==i3) return 
          enddo
        enddo
      enddo
      indice=-1
      return 
      end function
 
! ************************************************************ 
      function indice1(nmax,warr,w) 
      integer :: w(3),warr(nmax,3),indice1,i,w1(3)
 
      indice1=0 
      call ordina(w,w1)
      do i = 1,nmax
         indice1 = i
         if (warr(i,1)==w1(1).and.warr(i,2)==w1(2).and.warr(i,3)==w1(3)) return 
      enddo
      indice1 = -1
      
      return 
      end function
 
! ************************************************************ 
 
      subroutine vscambio(c,l) 
      integer :: l 
      real(dp) :: c(3) 
       
      select case(l) 
      case(2) 
       call vsost(c(1),c(2)) 
      case(3) 
       call vsost(c(2),c(3)) 
      case(4) 
       call vsost(c(1),c(3)) 
      case(5) 
       call vsost(c(1),c(2)) 
       call vsost(c(2),c(3)) 
      case(6) 
       call vsost(c(1),c(2)) 
       call vsost(c(1),c(3)) 
      end select 
      return 
      end subroutine
 
!  ***********************************************************        
      subroutine vinvers(c,l) 
      integer l 
      double precision c(3) 
       
      select case(l) 
      case(2) 
        c(1)=-c(1) 
        c(2)=-c(2) 
      case(3)
        c(2)=-c(2) 
        c(3)=-c(3) 
      case(4)
        c(1)=-c(1) 
        c(3)=-c(3)
      end select 
      return 
      end subroutine
!  ***************************************************************** 
 
      subroutine vsost(cx,cy) 
      real(dp) :: cx,cy,c 
      c=cx 
      cx=cy 
      cy=c 
      return 
      end subroutine
!  ***********************************************************  
      subroutine mscambio(e,l) 
      integer i,l 
      real(dp) :: e(4,4) 
      do i=1,4 
        call vscambio(e(i,2:4),l) 
      enddo
      do i=1,4 
        call vscambio(e(2:4,i),l) 
      enddo
      return 
      end subroutine
!  ***********************************************************  
      subroutine minvers(e,l) 
      integer i,l 
      real(dp) :: e(4,4) 
      do i=1,4 
        call vinvers(e(i,2:4),l) 
      enddo
      do i=1,4
        call vinvers(e(2:4,i),l) 
      enddo
      return
      end subroutine

!  ***********************************************************  
      subroutine rotatevect(v,v1,l)
       real(dp) :: v(3),v1(3)

       j=0
       v1=v
       do ls = 1,6
        do li = 1,4
         j=j+1
         if(j == l) then
          call vscambio(v1,ls)
          call vinvers(v1,li)
          return
         endif
        j=j+1
        if(j == l) then
         call vscambio(v1,ls)
         call vinvers(v1,li)
         v1=-v1
         return
        endif
       enddo
      enddo

     return
     end subroutine

!  ***********************************************************  
     subroutine rotatevectcmplx(v,v1,l)
     complex(dp) :: v(3),v1(3)
     real(dp) :: tmp(3),tmp1(3)

     call rotatevect(real(v),tmp,l)
     call rotatevect(dimag(v),tmp1,l)
     v1 = dcmplx(tmp,tmp1)
     
     return
     end subroutine

!  ***********************************************************  

     subroutine rotatevectcmplx8(v,v1,l)
     complex(dp) :: v(8),v1(8)
     complex(dp) :: tmp(3),tmp1(3),c,c1
      
     c = v(1)
     c1 = v(5)
     call rotatevectcmplx(v(2:4),tmp,l)
     call rotatevectcmplx(v(6:8),tmp1,l)
     if(mod(l,2)/=0) then
      v1(1) = c
      v1(2:4) = tmp
      v1(6:8) = tmp1
      v1(5) = c1
     else
      v1(1) = c1
      v1(2:4) = tmp1
      v1(6:8) = tmp
      v1(5) = c
     endif
             
     return
     end subroutine

!  ***********************************************************  

      subroutine rotatemat(e,e1,l) 
      real(dp) :: e(4,4),e1(4,4) 

      j=0
      e1=e 
      do ls = 1,6
         do li = 1,4 
          j=j+1   
          if(j == l) then 
             call mscambio(e1,ls) 
             call minvers(e1,li) 
             return 
          endif 
          j=j+1 
          if(j == l) then 
            call mscambio(e1,ls) 
            call minvers(e1,li) 
            e1=transpose(e1)    
            return
          endif 
        enddo
      enddo
 
      return 
      end subroutine
 
!  ***********************************************************  
      function is2(w) 
      logical is2 
      integer w(3) 
       
      is2=mod(w(1)+w(2)+w(3),2) 
       
      return 
      end function
!  ***********************************************************  

      subroutine sitiinput(nomefile,nmaxsiti,mmax,nsiti,iw)
      integer :: nmaxsiti,nsiti
      integer :: iw(nmaxsiti,3),mmax,i4,j
      character*50 :: nomefile  
      open(unit=1,file = nomefile,status='old')
!     open(unit=1,file='siti.dat',status='old')
      read(1,'(A)')
      read(1,'(A)')
      read(1,'(A)')
      i4 = 0
      j=0
      if(mmax==0) mmax = 1000
      do while (i4 <= mmax)
!       read(1,'(5i8)') i0,i1,i2,i3,i4
        read(1,*) i0,i1,i2,i3,i4
        if(i4>mmax) exit
        j=j+1
        iw(j,:)=(/i1,i2,i3/)
!       write(*,'(4i8)') j,iw(j,:)
        if(j==nmaxsiti) then
            write(*,*) ' Numero di siti > ',nmaxsiti
            return
        endif
      enddo
      close(1)
      nsiti=j

      return
      end subroutine


!  ***********************************************************  


      subroutine Hbuild(nmax,ivarr,H0,iv1,iv2,H)

      real(dp) :: H0(nmax,4,4),H(4,4),H1(4,4)
      integer :: nmax,iv1(3),iv2(3),iv(3),ifail,ivarr(nmax,3)
      
!     write(*,'(3i16)') transpose(ivarr)
!     write(*,'(4f16.6)') transpose(H0(1,:,:))
      iv = iv2 - iv1
      l = indice1(nmax,ivarr,iv)
      if(l==-1 .or. l>nmax) then
              H = 0.0_dp 
              return 
      else 
              ind = rsimm(iv) 
              H1 = H0(l,:,:) 
              call rotatemat(H1,H,ind) 
              if(mod(iv1(1),2)/=0.and.mod(iv2(1),2)/=0) then 
                      H = transpose(H) 
                      H(2:4,1)=-H(2:4,1) 
                      H(1,2:4)=-H(1,2:4) 
              endif 
      endif 
      return 
      end subroutine

!  ***********************************************************  
      subroutine Dbuild(nmax,ivarr,D0,iv,D,ifail)
      real(dp) :: D0(nmax,3,4,4),D(3,4,4),Dt(3,4,4)
      integer :: nmax,iv(3),ifail,ivarr(nmax,3)

!     l = indice(iv)
      l = indice1(nmax,ivarr,iv)
      ifail = l
      if(l==-1 .or. l>nmax) then
       D = 0.0_dp
       return
      else
       ind = rsimm(iv)
       do i = 1,3
        call rotatemat(D0(l,i,:,:),Dt(i,:,:),ind)
       enddo
!      write(*,*) ind
       do k1 = 1,4
        do k2 = 1,4
         call rotatevect(Dt(:,k1,k2),D(:,k1,k2),ind)
        enddo
       enddo
       if(mod(l,2)==0) D = -D
      endif

      return
      end subroutine


!  ***********************************************************

      subroutine Pbuild(nmax,ivarr,P0,iv,P,ifail)
      real(dp) :: P0(nmax,3,4,4),P(3,4,4),Pt(3,4,4)
      integer :: nmax,iv(3),ifail,ivarr(nmax,3)

!     l = indice(iv)
      l = indice1(nmax,ivarr,iv)
      ifail = l
      if(l==-1 .or. l>nmax) then
       P = 0.0_dp
       return
      else
       ind = rsimm(iv)
       do i = 1,3
        call rotatemat(P0(l,i,:,:),Pt(i,:,:),ind)
       enddo
!     write(*,*) ind
      do k1 = 1,4
       do k2 = 1,4
        call rotatevect(Pt(:,k1,k2),P(:,k1,k2),ind)
       enddo
      enddo
      endif

      return
      end subroutine


!  ***********************************************************
      subroutine Pbuild1(nmax,ivarr,P0,iv1,iv2,P)
      integer :: nmax,iv(3),ivarr(nmax,3),iv1(3),iv2(3)
      real(dp) :: P0(nmax,3,4,4),P(3,4,4),Pt(3,4,4)

        iv = iv2 - iv1
!       l = indice(iv)
        l = indice1(nmax,ivarr,iv)
        if(l==-1 .or. l>nmax) then
           P = 0.0_dp
           return
        else
           ind = rsimm(iv)
           do i = 1,3
            call rotatemat(P0(l,i,:,:),Pt(i,:,:),ind)
           enddo
!          write(*,*) ind
           do k1 = 1,4
            do k2 = 1,4
             call rotatevect(Pt(:,k1,k2),P(:,k1,k2),ind)
            enddo
           enddo
           if(mod(iv1(1),2)/=0.and.mod(iv2(1),2)/=0) then
                 do i = 1,3
                   P(i,:,:) = transpose(P(i,:,:))
                   P(i,2:4,1)=-P(i,2:4,1)
                   P(i,1,2:4)=-P(i,1,2:4)
                 enddo
           endif

     endif


    return
    end subroutine

!  *************************************************************
      subroutine Hinput(nomefile,nmax,natomi,ivarr,H0)
!     subroutine Hinput(nmax,natomi,ivarr,H0)
       integer :: iv(3),nmax
       real(dp) ::  H0(nmax,4,4),ehh,vss,vsp,passo
       integer :: ivarr(nmax,3)
       character*50 :: nomefile
       character*100 :: title
       namelist / infotbsi / ehh,vss,vsp,passo,n,title,norb,natomi

!      open(unit=1,file='tbsi.in',status='old')
!       write(*,*) nomefile
       open(unit=1,file = nomefile,status='old')
!      open(unit=1,file = 'tbsi.in',status='old')
        
       read(1,infotbsi)
       rewind(1)
!      write(*,*) title
!      write(*,*) ' natomi = ',natomi
!      write(*,*) ' norb = ',norb
!     write(*,*) ' passo = ',passo
!      write(*,infotbsi)
       if(natomi>nmax) then
               write(*,*) 'natoms too large'
               return
       endif
       read(1,'(a)')
       H0=0.0_dp
       ia=1
       ix=0
       iy=0
       iz=0
       ivarr(ia,:) = (/ix,iy,iz/)
       do i=1,norb
         ia0=ia
         ix0=ix
         iy0=iy
         iz0=iz
         iv = (/ix,iy,iz/)
         read(1,*) ii,ia,ix,iy,iz,i1,i2,H0(ia,i1,i2)
!        read(1,'(7i8,f26.16)') ii,ia,ix,iy,iz,i1,i2,H0(ia,i1,i2)
!        write(*,'(7i8,f26.16)') ii,ia,ix,iy,iz,i1,i2,H0(ia,i1,i2)
!        if((ia /= ia0).or.(i == nparam)) call completapmat(ix0,iy0,iz0,p0(ia0,:,:,:))
         if((ia /= ia0).or.(i == norb)) then
                 ivarr(ia0,:) = (/ix0,iy0,iz0/)
                 call completamat1(iv,H0(ia0,:,:))
            endif
       enddo 
      close(1)
!     write(*,'(3i5)') transpose(ivarr(:natomi,:))

      return
      end subroutine

!  *************************************************************
      subroutine Pinput(nomefile,nmax,natomi,ivarr,P0)
       integer :: iv(3),nmax,ix,iy,iz,ia,ia0,ix0,iy0,iz0,ii,i1,i2,ipv
       real(dp) ::  P0(nmax,3,4,4),passo
       integer :: ivarr(nmax,3),nparam,natomi,i,n
       character*50 :: nomefile
       character*100 :: title,units
       namelist / infopp / n,nparam,natomi,title,units

       open(unit=1,file = nomefile,status='old')
       read(1,infopp)
       rewind(1)
       if(natomi>nmax) then
               write(*,*) 'natomi too large'
               return
       endif
       read(1,'(a)')
       P0 = 0.0_dp
       ia=1
       ix=0
       iy=0
       iz=0
       ivarr(ia,1:3) = (/ix,iy,iz/)
       
       do i=1,nparam
         ia0=ia
         ix0=ix
         iy0=iy
         iz0=iz
         iv = (/ix,iy,iz/)
         read(1,*) ii,ia,ix,iy,iz,ipv,i1,i2,P0(ia,ipv,i1,i2)
         if((ia /= ia0).or.(i == nparam)) then
                 ivarr(ia0,1:3) = (/ix0,iy0,iz0/)
                 call completapmat1(iv,P0(ia0,1:3,1:4,1:4))
         endif
       enddo
      close(1)

      return
      end subroutine
!  *************************************************************
      subroutine Dinput(nomefile,nmax,natomi,ivarr,D0)
       integer :: iv(3),nmax
       real(dp) ::  D0(nmax,3,4,4),passo
       integer :: ivarr(nmax,3),nparam,n,natomi,i
       character*50 :: nomefile
       character*100 :: title,units
       namelist / infodd / n,nparam,natomi,title,units

       open(unit=1,file = nomefile,status='old')
       read(1,infodd)
       write(*,infodd)
       rewind(1)
       if(natomi>nmax) then
               write(*,*) 'natomi too large'
               return
       endif
       read(1,'(a)')
       D0 = 0.0_dp
       ia=1
       ix=0
       iy=0
       iz=0
       ivarr(ia,1:3) = (/ix,iy,iz/)
       do i=1,nparam
         ia0=ia
         ix0=ix
         iy0=iy
         iz0=iz
         iv(1:3) = (/ix,iy,iz/)
         read(1,*) ii,ia,ix,iy,iz,ipv,i1,i2,D0(ia,ipv,i1,i2)
!        write(*,*) ii,ia,ix,iy,iz,ipv,i1,i2,D0(ia,ipv,i1,i2)
!        read(1,'(8i8,f26.16)') ii,ia,ix,iy,iz,i1,i2,D0(ia,i1,i2)
!        if((ia /= ia0).or.(i == nparam)) call completadmat1(ix0,iy0,iz0,D0(ia0,:,:,:))
         if((ia /= ia0).or.(i == nparam)) then
                 ivarr(ia0,1:3) = (/ix0,iy0,iz0/)
!                write(*,*) 'Prima'
!                write(*,'(4f9.4)') D0(ia0,1,:,:)
                 call completadmat1(iv,D0(ia0,1:3,1:4,1:4))
!                write(*,*) 'Dopo'
!                write(*,'(4f9.4)') D0(ia0,1,:,:)
         endif
       enddo
      return
      close(1)
      return
      end subroutine

!  *************************************************************

      subroutine kweight(ix,iy,iz,n,w)
      integer :: c,c1,w,n,ix,iy,iz
      
       if(ix == iy) then
        if(iy == iz) then
         if(iz == 0) then 
            c = 48
         else
            c = 6
         endif
        else
         if(iz == 0) then
            c = 4
         else
            c = 2
         endif
        endif
       else
       if(iy == iz) then
        if(iz == 0) then 
           c = 8
        else
           c = 2
        endif
       else
        if(iz == 0) then
           c = 2
        else
           c = 1
        endif
       endif
      endif
      c1 = c
      if (2*(ix+iy+iz) == 3*n .or. ix == n)  c1 = 2*c
      if (ix == n.and.2*(iy+iz) == n) c1 = 3*c
      if ( 2*(ix+iy) ==3*n .and. iz == 0) c1 = 3*c      
      if (ix == n .and. 2*iy == n .and. iz == 0) c1 = 4*c

      w  = 48 / c1
      return
      end subroutine

 ! *******************************************************

      function inside(ix,iy,iz,n)
      inside=1
      iax=iabs(ix)
      iay=iabs(iy)
      iaz=iabs(iz)
      if (iax < iay) call isost(iax,iay)
      if (iax < iaz) call isost(iax,iaz)
      if (iay < iaz) call isost(iay,iaz)

      if(iax > N) inside = 0
      if (2*(iax+iay+iaz) > 3*n) inside=0
      if (2*(ix-iy-iz) == 3*n.and.iaz /= 0) inside=0
      if (2*(-ix+iy-iz) == 3*n.and.iaz /= 0) inside=0
      if (2*(-ix-iy+iz) == 3*n.and.iaz /= 0) inside=0
      if (2*(-ix-iy-iz) == 3*n.and.iaz /= 0) inside=0
      if (iax == n.and.iaz == 0.and.(2*ix == -n.or. &
       2*iy == -n.or.2*iz == -n)) inside=0
      if (iax == n.and.2*(iay+iaz) == n.and.  &
        2*iay /= n) inside=0
      return
      end function

! *******************************************************

      function vinside(rr)
      real(dp) :: rr(3),ax,ay,az,rx,ry,rz
      integer vinside
      vinside=1
!     eps = 1.0e-8
      ax=dabs(rr(1))
      ay=dabs(rr(2))
      az=dabs(rr(3))
      rx= rr(1)
      ry = rr(2)
      rz = rr(3)
      if (ax < ay) call vsost(ax,ay)
      if (ax < az) call vsost(ax,az)
      if (ay < az) call vsost(ay,az)
     
      if( ax > 1 ) vinside = 0
      if (2*(ax+ay+az)/3 - 1 > eps) vinside=0
      if (dabs(2*(-rx+ry+rz)/3 - 1) < eps .and. az > eps) vinside=0
      if (dabs(2*(+rx-ry+rz)/3 - 1) < eps .and. az > eps) vinside=0
      if (dabs(2*(rx+ry-rz)/3 - 1) < eps .and. az > eps) vinside=0
      if (dabs(2*(-rx-ry-rz)/3 -1) < eps .and. az > eps) vinside=0
!     write(6,*) 'vinside = ',vinside
      if (dabs(ax - 1) < eps .and. az < eps .and. ( dabs(2*rx + 1) < eps .or. &
       dabs(2*ry + 1) < eps .or. dabs(2*rz + 1) < eps)) vinside=0
      if (dabs(ax - 1) < eps .and. dabs(2*(ay+az) + 1) < eps .and.  &
        dabs(2*ay - 1) > eps ) vinside=0
      if(dabs(rx +1 ) < eps .or. dabs(ry + 1) < eps .or. dabs(rz + 1) < eps) vinside = 0
!     write(6,*) 'vinside = ',vinside
      return
      end function

! *******************************************************

      function carg(z)
	  complex(dp) :: z
      real(dp) :: carg,eps1	  
	  
	  if(dabs(dreal(z))< eps ) then  
       if(dabs(dimag(z)) < eps) then
	    carg  = 0.0_dp
		return
	   else				   
!	    carg = dimag(z)/eps
        carg = sign(pid2,dimag(z))
		return
	   endif
      else
       carg = dimag(z) / dreal(z)     
      endif
	  carg = datan(carg)
	  if(dreal(z) < -eps) carg = carg + pi
	  return
	  end function



! *******************************************************


end module

